## hatari 1.4.0

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(Hatari)

SET(APP_NAME "Hatari")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFiles)
include(CheckFunctionExists)

include(DistClean)

# Set build type to "Release" if user did not specify any build type yet
# Other possible values: Debug, Release, RelWithDebInfo and MinSizeRel
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_BUILD_TYPE)

# set(CMAKE_VERBOSE_MAKEFILE 1)

# ##########################
# Conditional build features
# ##########################

set(ENABLE_DSP_EMU 1
    CACHE BOOL "Enable DSP 56k emulator for Falcon mode")
set(ENABLE_TRACING 1
    CACHE BOOL "Enable tracing messages for debugging")
set(ENABLE_SMALL_MEM 0
    CACHE BOOL "Enable to use less memory - at the expense of emulation speed")

if(APPLE)
	set(ENABLE_OSX_BUNDLE 1
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
else()
	set(ENABLE_OSX_BUNDLE 0
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
endif(APPLE)

# ####################
# Check for libraries:
# ####################

find_package(SDL REQUIRED)
if(NOT SDL_FOUND)
	message(FATAL_ERROR "SDL library not found!")
endif(NOT SDL_FOUND)

find_package(Math)

find_package(Readline)
if(READLINE_FOUND)
	set(CMAKE_REQUIRED_LIBRARIES "readline")
	check_function_exists(rl_filename_completion_function HAVE_RL_COMPLETION_FUNCTION)
	if(HAVE_RL_COMPLETION_FUNCTION)
		set(HAVE_LIBREADLINE 1)
	else()
		unset(READLINE_FOUND)
	endif(HAVE_RL_COMPLETION_FUNCTION)
	set(CMAKE_REQUIRED_LIBRARIES "")
endif(READLINE_FOUND)

find_package(ZLIB)
if(ZLIB_FOUND)
	set(HAVE_LIBZ 1)
	set(HAVE_ZLIB_H 1)
endif(ZLIB_FOUND)

find_package(PNG)
if(PNG_FOUND)
	set(HAVE_LIBPNG 1)
endif(PNG_FOUND)

find_package(X11)
if(X11_FOUND)
	set(HAVE_X11 1)
endif(X11_FOUND)

find_package(PortAudio)
if(PORTAUDIO_FOUND)
	set(HAVE_PORTAUDIO 1)
endif(PORTAUDIO_FOUND)

# ################
# CPP Definitions:
# ################

add_definitions(-DCONFDIR=\"/etc\")

# Test for large file support:
execute_process(COMMAND getconf LFS_CFLAGS
                OUTPUT_VARIABLE DETECTED_LFS_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_LFS_CFLAGS)
	add_definitions(${DETECTED_LFS_CFLAGS})
	# message(STATUS "Large filesystem flags: ${DETECTED_LFS_CFLAGS}")
endif(DETECTED_LFS_CFLAGS)

# Additional CFLAGS suggested by the SDL library:
execute_process(COMMAND pkg-config --cflags-only-other sdl
                OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_SDL_CFLAGS)
	add_definitions(${DETECTED_SDL_CFLAGS})
	# message(STATUS "Additional CFLAGS of SDL: ${DETECTED_SDL_CFLAGS}")
endif(DETECTED_SDL_CFLAGS)

# ###########################
# Check for optional headers:
# ###########################

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(SDL/SDL_config.h HAVE_SDL_SDL_CONFIG_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files("sys/socket.h;sys/un.h" HAVE_UNIX_DOMAIN_SOCKETS)

# #############################
# Check for optional functions:
# #############################

check_function_exists(cfmakeraw HAVE_CFMAKERAW)
check_function_exists(setenv HAVE_SETENV)
check_function_exists(select HAVE_SELECT)
check_function_exists(posix_memalign HAVE_POSIX_MEMALIGN)
check_function_exists(memalign HAVE_MEMALIGN)

# #############
# Other CFLAGS:
# #############

# Warning flags:
if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "-Wcast-qual -Wbad-function-cast -Wpointer-arith ${CMAKE_C_FLAGS}")
	set(CMAKE_C_FLAGS "-Wmissing-prototypes -Wstrict-prototypes ${CMAKE_C_FLAGS}")
	set(CMAKE_C_FLAGS "-Wall -Wwrite-strings -Wsign-compare ${CMAKE_C_FLAGS}")
	# set(CMAKE_C_FLAGS "-Wshadow -Werror ${CMAKE_C_FLAGS}")
endif(CMAKE_COMPILER_IS_GNUCC)

# Building Hatari w/o optimization is no fun...
IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
	set(CMAKE_C_FLAGS "-O ${CMAKE_C_FLAGS}")
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

# ####################
# Paths configuration:
# ####################

if(NOT BINDIR)
	set(BINDIR bin)
endif()

if(NOT DATADIR)
	set(DATADIR share/hatari)
endif()

if(NOT BIN2DATADIR)
	if(WIN32)
		set(BIN2DATADIR "."
		    CACHE STRING "Relative path from bindir to datadir")
	elseif(ENABLE_OSX_BUNDLE)
		set(BIN2DATADIR "../Resources"
		    CACHE STRING "Relative path from bindir to datadir")
	else()
		set(BIN2DATADIR "../share/hatari"
		    CACHE STRING "Relative path from bindir to datadir")
	endif(WIN32)
	mark_as_advanced(BIN2DATADIR)
endif()

if(NOT MANDIR)
	set(MANDIR share/man/man1)
endif()

if(NOT DOCDIR)
	set(DOCDIR share/doc/hatari)
endif()

# #########################################
# Create config.h and recurse into subdirs:
# #########################################

configure_file(${CMAKE_SOURCE_DIR}/cmake/config-cmake.h
		${CMAKE_BINARY_DIR}/config.h)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(tools)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(python-ui)
endif(PYTHONINTERP_FOUND)

=== Makefile ===
# Top directory Makefile for Hatari.
#
# You can set DESTDIR as temporary installation prefix
# e.g. when creating RPM packages.

# Include settings
-include Makefile.cnf


all: Makefile.cnf config.h
	$(MAKE) -C src/
	$(MAKE) -C tools/hmsa/

# Makefile.cnf doesn't exist or is older than Makefile.default.cnf?
Makefile.cnf: Makefile-default.cnf
	@echo "Trying to use the default Makefile configuration..."
	@if [ -f Makefile.cnf ]; then \
		echo "ERROR: Makefile.cnf exists already, but is older than the default"; \
		echo "(just remove it if you haven't changed it)."; \
		exit 1; \
	elif [ x$(findstring indows,$(OS)) = x"indows" ]; then \
		cp -v Makefile-MinGW.cnf Makefile.cnf; \
	else \
		cp -v Makefile-default.cnf Makefile.cnf; \
	fi

# config.h doesn't exist or is older than config-default.h?
config.h: config-default.h
	@echo "Trying to use the default config.h configuration..."
	@if [ -f config.h ]; then \
		echo "ERROR: config.h exists already and is older than the default"; \
		echo "(just remove it if you haven't changed it, or re-run configure)."; \
		exit 1; \
	else \
		cp -v config-default.h config.h; \
	fi

hatari.1.gz: doc/hatari.1
	gzip -9 -c doc/hatari.1 > $@


clean:
	$(MAKE) -C src/ clean
	$(MAKE) -C tools/hmsa/ clean

distclean:
	$(MAKE) -C src/ distclean
	$(MAKE) -C tools/hmsa/ distclean
	$(RM) config.cache config.log Makefile.cnf config.h
	$(RM) hatari.1.gz


# Use "make depend" to generate file dependencies:
depend:
	$(MAKE) -C src/ depend

install: all hatari.1.gz
	@if [ "x$(INSTALL)" = "x" ]; then \
		echo; \
		echo "ERROR: Hatari isn't yet configured for installation."; \
		exit 1; \
	fi
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL) -d $(DESTDIR)$(DATADIR)
	$(INSTALL) -d $(DESTDIR)$(MANDIR)
	$(INSTALL) -d $(DESTDIR)$(DOCDIR)
	$(INSTALL) -d $(DESTDIR)$(DOCDIR)/images
	$(INSTALL_PROGRAM) src/hatari $(DESTDIR)$(BINDIR)/hatari
	$(INSTALL_PROGRAM) tools/hmsa/hmsa $(DESTDIR)$(BINDIR)/hmsa
	$(INSTALL_SCRIPT) tools/zip2st.sh $(DESTDIR)$(BINDIR)/zip2st
	$(INSTALL_DATA) src/hatari-icon.bmp $(DESTDIR)$(DATADIR)/hatari-icon.bmp
	if test -f src/tos.img -a \! -f $(DESTDIR)$(DATADIR)/tos.img ; then \
	  $(INSTALL_DATA) src/tos.img $(DESTDIR)$(DATADIR)/tos.img ; \
	fi
	$(INSTALL_DATA) hatari.1.gz $(DESTDIR)$(MANDIR)/
	$(INSTALL_DATA) doc/*.txt doc/*.html $(DESTDIR)$(DOCDIR)/
	$(INSTALL_DATA) doc/images/*.png $(DESTDIR)$(DOCDIR)/images/
	$(MAKE) -C python-ui/ install

=== python-ui/CMakeLists.txt ===

INSTALL(PROGRAMS hatari-console.py hatariui
	DESTINATION ${BINDIR})

INSTALL(PROGRAMS config.py dialogs.py hatari.py uihelpers.py
	hatariui.py debugui.py
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES README TODO release-notes.txt hatari-icon.png hatari.png
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES hatari-icon.png
	DESTINATION share/icons/hicolor/32x32/apps)

INSTALL(FILES hatariui.desktop
	DESTINATION share/applications)

# if(UNIX)
	add_custom_target(hatariui_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatariui.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		DEPENDS hatariui.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== python-ui/Makefile ===
# Makefile for installing Hatari UI
#
# TODO:
# - install separate startup/.desktop script for maemo
# - how to do byte-compile (*.pyc) and optimization (*.pyo)?

# Include settings
include ../Makefile.cnf

prefix ?= /usr

SCRIPT   = $(BINDIR)/hatariui
DATAPATH = $(DATADIR)/hatariui
ICONPATH = $(prefix)/share/icons/hicolor/32x32/apps
DESKPATH = $(prefix)/share/applications

all:
	@echo "Nothing to build, just do 'make install'"

hatariui.1.gz: hatariui.1
	gzip -9 -c $<  >  $@

install: hatariui.1.gz
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL_SCRIPT) hatari-console.py $(DESTDIR)$(BINDIR)/
	sed -e "s%^path=.*$$%path=$(DATAPATH)%" -e "s%^conf=.*$$%conf=$(CONFDIR)%" hatariui > $(DESTDIR)$(SCRIPT)
	chmod 755 $(DESTDIR)$(SCRIPT)
	$(INSTALL) -d $(DESTDIR)$(MANDIR)
	$(INSTALL_DATA) hatariui.1.gz $(DESTDIR)$(MANDIR)/
	$(INSTALL) -d $(DESTDIR)$(DATAPATH)
	$(INSTALL_SCRIPT) hatariui.py debugui.py $(DESTDIR)$(DATAPATH)/
	$(INSTALL_DATA) config.py dialogs.py hatari.py uihelpers.py $(DESTDIR)$(DATAPATH)/
	$(INSTALL_DATA) README TODO release-notes.txt *.png $(DESTDIR)$(DATAPATH)/
	$(INSTALL) -d $(DESTDIR)$(ICONPATH)
	$(INSTALL_DATA) hatari-icon.png $(DESTDIR)$(ICONPATH)/
	$(INSTALL) -d $(DESTDIR)$(DESKPATH)
	$(INSTALL_DATA) hatariui.desktop $(DESTDIR)$(DESKPATH)/

=== src/CMakeLists.txt ===

set(SOURCES
	audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c
	configuration.c options.c  createBlankImage.c change.c
	control.c cycInt.c cycles.c dialog.c dmaSnd.c fdc.c file.c
	floppy.c gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c ioMem.c
	ioMemTabST.c ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c
	keymap.c m68000.c main.c midi.c memorySnapShot.c mfp.c
	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
	scandir.c stMemory.c screen.c screenSnapShot.c shortcut.c sound.c
	spec512.c statusbar.c str.c tos.c unzip.c utils.c vdi.c
	video.c wavFormat.c xbios.c ymFormat.c)

# Disk image code is shared with the hmsa tool, so we put it into a library:
add_library(Floppy  dim.c msa.c st.c zip.c)

# When building for OSX, define specific sources for gui and ressources
if(ENABLE_OSX_BUNDLE)
	set(GUIOSX_SOURCES
	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m)
	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
	set(GUIOSX_RSRCS
	    gui-osx/Hatari.icns gui-osx/English.lproj gui-osx/French.lproj)
endif(ENABLE_OSX_BUNDLE)

# When building for Windows, define specific sources for gui and ressources
if(WIN32)
	set(GUIWIN_SOURCES gui-win/opencon.c)
	set(GUIWIN_RES gui-win/hatari-winicon.rc)
endif(WIN32)

include_directories(${CMAKE_BINARY_DIR} includes debug falcon uae-cpu
		    ${SDL_INCLUDE_DIR})

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	include_directories(${PNG_INCLUDE_DIR})
endif(PNG_FOUND)

if(X11_FOUND)
	include_directories(${X11_INCLUDE_DIR})
endif(X11_FOUND)


link_directories(debug falcon gui-sdl uae-cpu) 

add_subdirectory(debug)
add_subdirectory(falcon)
add_subdirectory(gui-sdl)
add_subdirectory(uae-cpu)

# When building for OSX, add specific sources
if(ENABLE_OSX_BUNDLE)
	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${SOURCES} ${GUIOSX_SOURCES})
	set_target_properties(hatari PROPERTIES MACOSX_BUNDLE_INFO_PLIST
			      ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/Info-Hatari.plist)
	set(MACOSX_BUNDLE_ICON_FILE Hatari.icns)
	# Create Hatari.app bundle
	add_custom_target(osx_bundle_dirs
			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources
			COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/MacOS
			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
				   ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/${MACOSX_BUNDLE_ICON_FILE}
			# Copy Localized .nib to Bundle
			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents/Resources/
	)	
	add_dependencies(hatari osx_bundle_dirs)
	set_source_files_properties(${GUIOSX_RSRCS}
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

# When building for Windows, add specific sources + method to compile .rc files
elseif(WIN32)
	# Set a default rc compiler if it was not defined yet
	if(NOT CMAKE_RC_COMPILER)
		set(CMAKE_RC_COMPILER windres)
	endif(NOT CMAKE_RC_COMPILER)
	ENABLE_LANGUAGE(RC)
	set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -Ocoff -o <OBJECT> <SOURCE>")
	set_source_files_properties(${GUIWIN_RES} PROPERTIES LANGUAGE RC)
	add_executable(hatari ${GUIWIN_RES} ${SOURCES} ${GUIWIN_SOURCES})

# Other targets, use default sources
else()
	add_executable(hatari ${SOURCES})
endif(ENABLE_OSX_BUNDLE)

target_link_libraries(hatari Floppy Debug Falcon GuiSdl UaeCpu ${SDL_LIBRARY})

if(MATH_FOUND AND NOT APPLE)
	target_link_libraries(hatari ${MATH_LIBRARY})
endif()

if(SDLMAIN_LIBRARY)
	target_link_libraries(hatari ${SDLMAIN_LIBRARY})
endif(SDLMAIN_LIBRARY)

if(READLINE_FOUND)
	target_link_libraries(hatari ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hatari ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	target_link_libraries(hatari ${PNG_LIBRARY})
endif(PNG_FOUND)

if(X11_FOUND)
	target_link_libraries(hatari ${X11_X11_LIB})
endif(X11_FOUND)

if(PORTAUDIO_FOUND)
	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
endif(PORTAUDIO_FOUND)

if(WIN32)
	# Needed for socket() on Windows
	target_link_libraries(hatari ws2_32)
endif(WIN32)


if(ENABLE_OSX_BUNDLE)
	install(TARGETS hatari BUNDLE DESTINATION /Applications)
else()
	install(TARGETS hatari RUNTIME DESTINATION ${BINDIR})
	install(FILES hatari-icon.bmp DESTINATION ${DATADIR})
	file(GLOB TOS_IMG_FILE tos.img)
	if(TOS_IMG_FILE)
		install(FILES tos.img DESTINATION ${DATADIR})
	endif(TOS_IMG_FILE)
endif(ENABLE_OSX_BUNDLE)

=== src/Makefile ===
# Main Makefile for Hatari.

# Use "export ENABLE_DSP_EMU=0" & "make clean"
# to disable experimental DSP emulation code.
ENABLE_DSP_EMU ?= 1

# Select CPU directory:
CPUDIR = uae-cpu

# Include settings
include ../Makefile.cnf

# Additional include directories:
CPPFLAGS += -I.. -I./includes -I$(CPUDIR) -I./debug -I./falcon \
 -DCONFDIR=\"$(CONFDIR)\" $(SDL_CFLAGS) $(PNG_CFLAGS) $(X11_CFLAGS)

ifeq ($(ENABLE_DSP_EMU),1)
CPPFLAGS += -DENABLE_DSP_EMU=1
endif

SRCS = audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c \
  configuration.c options.c  createBlankImage.c change.c control.c \
  cycInt.c cycles.c dialog.c dim.c dmaSnd.c fdc.c file.c floppy.c \
  gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c ioMem.c ioMemTabST.c \
  ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c keymap.c m68000.c \
  main.c midi.c memorySnapShot.c mfp.c msa.c paths.c  psg.c printer.c \
  resolution.c rs232.c reset.c rtc.c scandir.c st.c stMemory.c screen.c \
  screenSnapShot.c shortcut.c sound.c spec512.c statusbar.c str.c tos.c \
  unzip.c utils.c vdi.c video.c wavFormat.c xbios.c ymFormat.c zip.c

OBJS = $(SRCS:.c=.o)

SUBDIRLIBS = $(CPUDIR)/cpu68k.a debug/debug.a falcon/falcon.a gui-sdl/gui-sdl.a

ifeq ($(SYS_WINDOWS),1)
  SUBDIRLIBS += gui-win/gui-win.a 
  OBJS += gui-win/hatari-winicon.o
else
ifneq ($(strip $(shell gcc -v 2>&1 |grep "cygwin")),)
  SUBDIRLIBS += gui-win/gui-win.a 
endif 
endif

SUBDIRS = $(dir $(SUBDIRLIBS))
ALLOBJS = $(OBJS) $(SUBDIRLIBS)


.PHONY : all
all: ../Makefile.cnf
	$(MAKE) $(SUBDIRS)
	$(MAKE) hatari

LIBS := $(PORTAUDIO_LIBS) $(PNG_LIBS) $(SDL_LIBS) $(X11_LIBS) $(LIBS)

hatari: $(ALLOBJS)
	$(CC) $(LDFLAGS) $(ALLOBJS) $(LIBS) -o hatari

# Sub-folder dependencies:
.PHONY : $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) ENABLE_DSP_EMU=$(ENABLE_DSP_EMU) CPUDIR=$(CPUDIR) -C $@


clean:
	$(RM) *.o hatari
	$(MAKE) -C gui-sdl/ clean
	$(MAKE) -C gui-win/ clean
	$(MAKE) -C $(CPUDIR) clean
	$(MAKE) -C falcon/ clean
	$(MAKE) -C debug/ clean

distclean:
	$(RM) *.o hatari
	$(RM) Makefile.dep *~ *.bak *.orig
	$(RM) convert/*~ convert/*.bak
	$(MAKE) -C gui-sdl/ distclean
	$(MAKE) -C gui-win/ distclean
	$(MAKE) -C $(CPUDIR) distclean
	$(MAKE) -C falcon/ distclean
	$(MAKE) -C debug/ distclean


# Use "make depend" to generate file dependencies:
Makefile.dep: Makefile ../Makefile.cnf
	$(CC) -M $(CPPFLAGS) $(SRCS) > Makefile.dep

.PHONY : depend
depend:
	$(MAKE) cleandeps
	$(MAKE) Makefile.dep
	$(MAKE) -C gui-sdl/ depend
	$(MAKE) -C $(CPUDIR) depend
	$(MAKE) -C falcon/ depend
	$(MAKE) -C debug/ depend

.PHONY : cleandeps
cleandeps:
	$(RM) Makefile.dep */Makefile.dep

-include Makefile.dep

=== tests/Makefile ===
# Makefile for testing Hatari features

# Include settings
include ../Makefile.cnf


VALGRIND_OPTS = --leak-check=full --leak-resolution=high \
  --free-fill=0 --error-exitcode=1

# Additional include directories:
INCFLAGS = -I.. -I../src/includes -I../src/uae-cpu \
  -I../src/debug -I../src/falcon

# Set extra flags passed to the compiler
CFLAGS += $(INCFLAGS) $(SDL_CFLAGS) $(LDFLAGS)


TESTS = test-symbols test-evaluate test-breakcond

all: $(TESTS)

# To do mudflap checks, use:
# 	make clean; make MUDFLAP=1 mudflap
#
# "-check-initialization" can be used here because these tests don't
# handle data initialized in external libraries (like Hatari uses
# SDL surface structs initialized by SDL).
# 
# "-print-leaks" can be used because these tests don't utilize external
# libraries which leave their resources behind on exit (like SDL audio
# and X locale stuff).
mudflap: $(TESTS)
	export MUDFLAP_OPTIONS="-viol-gdb -collect-stats -internal-checking -print-leaks -backtrace=8 -check-initialization -wipe-stack -wipe-heap"; \
	for test in $^; do ./$$test; echo "Press <Enter>"; read; done

valgrind: $(TESTS)
	for test in $^; do valgrind $(VALGRIND_OPTS) ./$$test; done


test-symbols: test-symbols.c ../src/debug/symbols.c
	$(CC) $(CFLAGS) -o $@ $^

test-evaluate: test-evaluate.c ../src/debug/evaluate.c \
		../src/debug/debugcpu.c ../src/falcon/dsp.c \
		../src/debug/symbols.c ../src/str.c \
		../src/debug/breakcond.c test-dummies.c
	$(CC) $(CFLAGS) -o $@ $^

test-breakcond: test-breakcond.c ../src/debug/breakcond.c \
		../src/debug/debugcpu.c ../src/falcon/dsp.c \
		../src/debug/symbols.c ../src/str.c \
		../src/debug/evaluate.c test-dummies.c
	$(CC) $(CFLAGS) -o $@ $^


clean:
	$(RM) *.o $(TESTS)

distclean: clean
	$(RM) *~ *.bak *.orig

=== tools/CMakeLists.txt ===

install(PROGRAMS atari-hd-image.sh zip2st.sh  DESTINATION ${BINDIR})

add_subdirectory(hmsa)

=== src/debug/CMakeLists.txt ===

if(READLINE_FOUND)
	include_directories(${READLINE_INCLUDE_DIR})
endif(READLINE_FOUND)

if(ENABLE_DSP_EMU)
	set(DSPDBG_C debugdsp.c)
endif(ENABLE_DSP_EMU)

add_library(Debug
            log.c debugui.c breakcond.c debugcpu.c debugInfo.c
            ${DSPDBG_C} evaluate.c symbols.c)

=== src/debug/Makefile ===
# Makefile for Hatari's debugging & tracing support.

CPUDIR ?= uae-cpu

# Include settings
include ../../Makefile.cnf

# Additional include directories:
INCFLAGS = -I. -I../.. -I../includes -I../$(CPUDIR) -I../falcon $(CPPFLAGS)

SRCS = log.c debugui.c breakcond.c debugcpu.c debugInfo.c symbols.c evaluate.c
ifeq ($(ENABLE_DSP_EMU),1)
SRCS += debugdsp.c
INCFLAGS += -DENABLE_DSP_EMU=1
endif

# Set extra flags passed to the compiler
CFLAGS += $(INCFLAGS) $(SDL_CFLAGS)


OBJS = $(SRCS:.c=.o)

all: debug.a

debug.a: $(OBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@


clean:
	$(RM) *.o debug.a

distclean: clean
	$(RM) Makefile.dep *~ *.bak *.orig


# Use "make depend" to generate file dependencies:
Makefile.dep: Makefile ../Makefile
	$(CC) -M $(CFLAGS) $(SRCS) > Makefile.dep

depend: Makefile.dep

-include Makefile.dep

=== src/falcon/Makefile ===
# Makefile for Hatari's Falcon support.

CPUDIR ?= uae-cpu

# Include settings
include ../../Makefile.cnf

# Additional include directories:
INCFLAGS = -I../.. -I../includes -I../debug -I../$(CPUDIR) \
  $(CPPFLAGS) $(PORTAUDIO_CFLAGS)

FALCSRCS = videl.c hostscreen.c nvram.c dsp.c crossbar.c microphone.c
ifeq ($(ENABLE_DSP_EMU),1)
FALCSRCS += dsp_core.c dsp_cpu.c dsp_disasm.c
INCFLAGS += -DENABLE_DSP_EMU=1
endif

# Set flags passed to the compiler (e.g. optimization flags)
#CFLAGS := -g -O2 -Wall

CFLAGS += $(INCFLAGS) $(SDL_CFLAGS)

FALCOBJS = $(FALCSRCS:.c=.o)


all: falcon.a

falcon.a: $(FALCOBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@


clean:
	$(RM) *.o falcon.a

distclean: clean
	$(RM) Makefile.dep *~ *.bak *.orig


# Use "make depend" to generate file dependencies:
Makefile.dep: Makefile ../Makefile
	$(CC) -M $(CFLAGS) $(FALCSRCS) > Makefile.dep

depend: Makefile.dep

-include Makefile.dep

=== src/gui-sdl/Makefile ===
# Makefile for Hatari's SDL GUI.

# Include settings
include ../../Makefile.cnf

# Additional include directories:
INCFLAGS = -I../.. -I../debug -I../includes $(CPPFLAGS)

CFLAGS += $(INCFLAGS) $(SDL_CFLAGS) -Wno-write-strings


DLGSRCS = dlgAbout.c dlgAlert.c dlgDevice.c dlgFloppy.c dlgHardDisk.c \
  dlgJoystick.c dlgKeyboard.c dlgMain.c dlgMemory.c dlgNewDisk.c dlgRom.c \
  dlgScreen.c dlgSound.c dlgSystem.c dlgFileSelect.c sdlgui.c


DLGOBJS = $(DLGSRCS:.c=.o)


all: gui-sdl.a

gui-sdl.a: $(DLGOBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@


font5x8.h: font5x8.bmp
	convert font5x8.bmp xbm:font5x8.h

font10x16.h: font10x16.bmp
	convert font10x16.bmp xbm:font10x16.h


clean:
	$(RM) *.o gui-sdl.a

distclean: clean
	$(RM) Makefile.dep *~ *.bak *.orig


# Use "make depend" to generate file dependencies:
Makefile.dep: Makefile ../Makefile
	$(CC) -MM $(CFLAGS) $(DLGSRCS) > Makefile.dep

depend: Makefile.dep

-include Makefile.dep

=== debian/changelog ===
hatari (1.4.0-1) unstable; urgency=low

  * New upstream version.
  * Update to debhelper 7.
  * Adapt to CMake.
  * Add build-dependency on portaudio for Falcon microphone input.
  * Add build-dependency on readline for command line editing in the
    debugger.
  * Use python-support for python-dependencies.
  * Suggest mtools and unzip so that zip2st might actually be useful.
  * Suggest dosfstools so that atari-hd-image might actually be useful.
  * Update Standards-Version, no changes needed.
  * Remove script extensions (.sh, .py) from scripts installed into
    /usr/bin.
  * Include experimental python-ui.
  * Add manpages for newly included tools.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 19 Jun 2010 21:40:55 +0300

hatari (1.3.1-1) unstable; urgency=low

  * New upstream bugfix release

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 03 Oct 2009 12:33:28 +0300

hatari (1.3.0-1) unstable; urgency=low

  * New upstream release
    - Improved Falcon emulation (DSP emulation allows running many
      programs which use the DSP)
    - Improved video emulation (sync fixes)

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 25 Aug 2009 20:32:45 +0300

hatari (1.2.0-1) unstable; urgency=low

  * New upstream release
    - Fixed a bug that could write data to the wrong disk image (resulting
      in data loss)
    - Various emulation fixes (midi input, ste hardware scrolling in med res,
      etc.)

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Fri, 30 Jan 2009 20:48:48 +0200

hatari (1.1.0-1) unstable; urgency=low

  * New upstream release (Closes: #509856)
  * Project moved to berlios,
    * Updated Homepage and watch-file.
  * Included new documentation files.
  * Updated description.
  * Updated Standards-Version.
  * Updated Build-Depends.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 18 Jan 2009 20:38:20 +0200

hatari (1.0.1-1) unstable; urgency=low

  * New upstream release (Closes: #473779). Fixes bugs in showing a lot
    of old demos.
  * Removed all patches, as they came from upstream HEAD, and are in the
    new release. Removed patch system and build-dependency on quilt.
  * Updated debhelper compatibility level to 5.
  * Updated watch file.
  * Fixed unquoted dashes in manpage
  * Set myself as maintainer.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Thu, 01 May 2008 20:54:32 +0300

hatari (0.95-2) unstable; urgency=low

  * Updated Standards-Version to 3.7.3
  * Added Homepage header.
  * Added longtitle for menu.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Thu, 06 Dec 2007 21:49:33 +0200

hatari (0.95-1) unstable; urgency=low

  * New upstream release.
  * Using quilt for patches.
  * Pulled patches from upstream cvs:
    * 10-fix-mouse-scaling-in-vdi-mode
    * 20-cfgopts-refactoring
    * 30-autoconf-datarootdir
  * Removed hatari.xpm, upstream ships an icon now.
  * Convert upstream icon when building, added build-dep on netpbm.
  * Fixed nostrip option (Closes: #437156)
  * Updated menu section for menu transition.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 11 Aug 2007 20:15:15 +0300

hatari (0.90-1) unstable; urgency=low

  * Initial upload to Debian. (Closes: #229266)

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Wed, 18 Oct 2006 19:51:25 +0300

hatari (0.80+cvs20060815-1) unstable; urgency=low

  * CVS snapshot, pre-0.84.
  * Updated debian/copyright for the actual copyright.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 15 Aug 2006 19:05:23 +0300

hatari (0.80-2) unstable; urgency=low

  * removed essential package gcc from build-depends 
  * expect the global config file in /etc instead of /usr/etc

 -- Marco Herrn <marco@mherrn.de>  Sat, 15 Oct 2005 19:45:12 +0200

hatari (0.80-1) unstable; urgency=low

  * new upstream version
    - Support for STE hardware emulation: STE palette, STE shifter (horizontal
      fine  scrolling, split screen effects), DMA sound and STE joypads.
    - Hatari can now emulate up to 14 MiB ST RAM instead of only 4 MiB.
    - Support for parallel port joysticks.
    - Improved GEMDOS HD emulation (added Fattrib() call).
    - Adding and removing a GEMDOS or ACSI hard disk should now work correctly.
    - Re-factoring of the screen conversion functions.
    - Improved manual: Now with screenshots of the options dialogs.

 -- Marco Herrn <marco@mherrn.de>  Thu, 13 Oct 2005 09:05:29 +0200

hatari (0.70-1) unstable; urgency=low

  * new upstream version
    - No more crashes when a program tries to access illegal sector numbers.
    - Improved built-in ROM cartridge.
    - Rewrote the IO memory emulation code -> Better compatibility.
    - Support for TOS 1.06 and TOS 1.62
    - Emulated CPU can now also be run at 16 MHz or 32 MHz.
    - File selection dialog scrollable with mouse wheel or cursor keys, too.
    - Hatari now works on 64-bit host CPUs, too.
    - Floppy disk images can now be set writable/write-protected in the GUI.
    - Hatari can now also load a global configuration file (e.g. /etc/hatari.cfg).
    - Configurable logging functions.
    - Code cleanup and bug fixes.        

 -- Marco Herrn <marco@mherrn.de>  Sun, 12 Jun 2005 20:06:53 +0200

hatari (0.60-2) unstable; urgency=low

  * inform the user of the changes in the config file
  * provide a new icon, because the old one would raise copyright
    problems 

 -- Marco Herrn <marco@mherrn.de>  Sun, 13 Feb 2005 17:00:25 +0100

hatari (0.60-1) unstable; urgency=low

  * new upstream version
    - mostly bugfixes
    - possibility to load external cardridge ROM images
    - improvements in the graphical user interface 
  * added a control file for the Debian BTS. Bug reports can
    now be submitted with 'reportbug'.
  * do not treat the changelog.txt file as a normal documentation file
    anymore, but instead as the upstream changelog

 -- Marco Herrn <marco@mherrn.de>  Fri, 28 Jan 2005 20:40:36 +0100

hatari (0.50-2) unstable; urgency=low

  * now includes a pixmap image

 -- Marco Herrn <marco@mherrn.de>  Sun, 24 Oct 2004 20:05:37 +0200

hatari (0.50-1) unstable; urgency=low

  * new upstream version


=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends: debhelper (>= 7.0.50), libsdl1.2-dev (>=1.2.6-2), zlib1g-dev, libpng12-dev, cmake, libreadline-dev, libportaudio-dev, python-support
Standards-Version: 3.8.4
Homepage: http://hatari.berlios.de/

Package: hatari
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Suggests: mtools, unzip, dosfstools
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by Atari
 in 1985. Using the Motorola 68000 CPU, it was a very popular computer having
 quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and demos.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake --builddirectory=build $@

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_install:
	mv debian/tmp/usr/bin/atari-hd-image.sh \
	 debian/tmp/usr/bin/atari-hd-image
	mv debian/tmp/usr/bin/zip2st.sh debian/tmp/usr/bin/zip2st
	mv debian/tmp/usr/bin/hatari-console.py \
	 debian/tmp/usr/bin/hatari-console
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs doc/changelog.txt

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=3
opts=downloadurlmangle=s/prdownload/download/ \
	http://developer.berlios.de/project/showfiles.php?group_id=10436 \
	http://prdownload.berlios.de/hatari/hatari-(.*).tar.bz2

## hatari 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
 
-project(Hatari)
+project(Hatari C)
 
 SET(APP_NAME "Hatari")
 
@@ -9,7 +9,7 @@
 
 include(CheckIncludeFiles)
 include(CheckFunctionExists)
-
+include(CheckCCompilerFlag)
 include(DistClean)
 
 # Set build type to "Release" if user did not specify any build type yet
@@ -30,6 +30,35 @@
     CACHE BOOL "Enable tracing messages for debugging")
 set(ENABLE_SMALL_MEM 0
     CACHE BOOL "Enable to use less memory - at the expense of emulation speed")
+set(ENABLE_WINUAE_CPU 0
+    CACHE BOOL "Enable WinUAE CPU core (experimental!)")
+
+# Run-time checks with GCC "mudflap" etc features:
+# - stack protection
+# - checking of pointer accesses
+#
+# Before running CMake, install "libmudflap<version>-<gcc-version>-dev"
+# package (libmudflap0-4.3-dev in Debian Lenny).
+#
+# After this you can configure Hatari with Mudflap:
+#   cd build; make clean; cmake -D ENABLE_MUDFLAP:BOOL=1 -D ..
+# If everything's fine, CMake output should include:
+#   Performing Test MUDFLAP_AVAILABLE - Success"
+#
+# After (re-)building Hatari, run it with something like this:
+#   MUDFLAP_OPTIONS="-viol-gdb" src/hatari --sound off --mic off
+# (sound&mic are disabled because threading doesn't work well with Mudflap)
+#
+# For more info:
+#   http://gcc.gnu.org/wiki/Mudflap_Pointer_Debugging
+#
+set(CMAKE_REQUIRED_LIBRARIES "mudflap")
+CHECK_C_COMPILER_FLAG("-fmudflapth" MUDFLAP_AVAILABLE)
+set(CMAKE_REQUIRED_LIBRARIES "")
+if(MUDFLAP_AVAILABLE)
+	set(ENABLE_MUDFLAP 0
+	    CACHE BOOL "Enable GCC run-time stack/pointer debugging - with huge slowdown")
+endif(MUDFLAP_AVAILABLE)
 
 if(APPLE)
 	set(ENABLE_OSX_BUNDLE 1
@@ -92,8 +121,6 @@
 # CPP Definitions:
 # ################
 
-add_definitions(-DCONFDIR=\"/etc\")
-
 # Test for large file support:
 execute_process(COMMAND getconf LFS_CFLAGS
                 OUTPUT_VARIABLE DETECTED_LFS_CFLAGS
@@ -132,17 +159,30 @@
 check_function_exists(select HAVE_SELECT)
 check_function_exists(posix_memalign HAVE_POSIX_MEMALIGN)
 check_function_exists(memalign HAVE_MEMALIGN)
+check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
+check_function_exists(nanosleep HAVE_NANOSLEEP)
+check_function_exists(alphasort HAVE_ALPHASORT)
+check_function_exists(scandir HAVE_SCANDIR)
 
 # #############
 # Other CFLAGS:
 # #############
 
+# GCC pointer debugging, huge run-time slowdown
+if(ENABLE_MUDFLAP)
+	# SDL mixer threads so have to use threaded mudflap version
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fstack-protector-all -fmudflapth")
+	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fmudflapth -lmudflap")
+endif(ENABLE_MUDFLAP)
+
 # Warning flags:
 if(CMAKE_COMPILER_IS_GNUCC)
-	set(CMAKE_C_FLAGS "-Wcast-qual -Wbad-function-cast -Wpointer-arith ${CMAKE_C_FLAGS}")
-	set(CMAKE_C_FLAGS "-Wmissing-prototypes -Wstrict-prototypes ${CMAKE_C_FLAGS}")
-	set(CMAKE_C_FLAGS "-Wall -Wwrite-strings -Wsign-compare ${CMAKE_C_FLAGS}")
-	# set(CMAKE_C_FLAGS "-Wshadow -Werror ${CMAKE_C_FLAGS}")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
+	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
+	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
 endif(CMAKE_COMPILER_IS_GNUCC)
 
 # Building Hatari w/o optimization is no fun...
@@ -184,6 +224,15 @@
 	set(DOCDIR share/doc/hatari)
 endif()
 
+if(NOT ETCDIR)
+	if(WIN32)
+		set(ETCDIR .)
+	else()
+		set(ETCDIR /etc)
+	endif()
+endif()
+add_definitions(-DCONFDIR=\"${ETCDIR}\")
+
 # #########################################
 # Create config.h and recurse into subdirs:
 # #########################################
@@ -199,3 +248,6 @@
 if(PYTHONINTERP_FOUND)
 	add_subdirectory(python-ui)
 endif(PYTHONINTERP_FOUND)
+
+add_custom_target(uninstall
+    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Uninstall.cmake)

=== python-ui/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-INSTALL(PROGRAMS hatari-console.py hatariui
+INSTALL(PROGRAMS hatariui
 	DESTINATION ${BINDIR})
 
 INSTALL(PROGRAMS config.py dialogs.py hatari.py uihelpers.py

=== src/debug/CMakeLists.txt ===
--- 
+++ 
@@ -9,4 +9,4 @@
 
 add_library(Debug
             log.c debugui.c breakcond.c debugcpu.c debugInfo.c
-            ${DSPDBG_C} evaluate.c symbols.c)
+            ${DSPDBG_C} evaluate.c profile.c symbols.c 68kDisass.c)

=== debian/changelog ===
hatari (1.5.0-1) unstable; urgency=low

  * New upstream release.
  * Add binfmt-support for TOS binaries.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Thu, 28 Jul 2011 15:36:38 +0300

hatari (1.4.0-2) unstable; urgency=low

  * Switch to portaudio19. (Closes: #594016)
  * Bump Standards-Version, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 26 Jun 2011 19:59:29 +0300

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,21 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
-Build-Depends: debhelper (>= 7.0.50), libsdl1.2-dev (>=1.2.6-2), zlib1g-dev, libpng12-dev, cmake, libreadline-dev, libportaudio-dev, python-support
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7.0.50),
+               libsdl1.2-dev (>=1.2.6-2),
+               zlib1g-dev,
+               libpng12-dev,
+               cmake,
+               libreadline-dev,
+               portaudio19-dev,
+               python-support
+Standards-Version: 3.9.2.0
 Homepage: http://hatari.berlios.de/
 
 Package: hatari
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
+Recommends: binfmt-support
 Suggests: mtools, unzip, dosfstools
 Description: Emulator for the Atari ST, STE, TT, and Falcon computers
  Hatari is an emulator for the Atari ST line of computers.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake --builddirectory=build $@

override_dh_install:
	dh_install -O--buildsystem=cmake -O--builddir=build
	rm debian/hatari/usr/share/hatari/tos.img
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_auto_clean:
	dh_auto_clean $@
	find . -name *.pyc -exec rm -f {} \;

=== debian/watch ===
version=3
opts=downloadurlmangle=s/prdownload/download/ \
	http://developer.berlios.de/project/showfiles.php?group_id=10436 \
	http://prdownload.berlios.de/hatari/hatari-(.*).tar.bz2

## hatari 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -163,6 +163,7 @@
 check_function_exists(nanosleep HAVE_NANOSLEEP)
 check_function_exists(alphasort HAVE_ALPHASORT)
 check_function_exists(scandir HAVE_SCANDIR)
+check_function_exists(statvfs HAVE_STATVFS)
 
 # #############
 # Other CFLAGS:

=== debian/changelog ===
hatari (1.6.0-1) unstable; urgency=low

  * New upstream version.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 01 Jan 2012 15:59:51 +0000

hatari (1.5.0-2) unstable; urgency=low

  * Upstream moved to tuxfamily.org, update homepage and watch file
    accordingly.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 20 Dec 2011 20:05:41 +0000

=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends: debhelper (>= 7.0.50),
               libsdl1.2-dev (>=1.2.6-2),
               zlib1g-dev,
               libpng12-dev,
               cmake,
               libreadline-dev,
               portaudio19-dev,
               python-support,
               chrpath
Standards-Version: 3.9.2.0
Homepage: http://hatari.tuxfamily.org/

Package: hatari
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: binfmt-support
Suggests: mtools, unzip, dosfstools
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and
 demos.

## hatari 1.6.1

=== debian/changelog ===
hatari (1.6.1-3) unstable; urgency=low

  * Use dh_python2.
  * Disable rpath usage by commanding cmake instead of removing rpath
    after the build.
  * Use -Wl,--as-needed when linking.
  * Disable cmake colour output.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 12 Feb 2012 21:38:14 +0000

hatari (1.6.1-2) unstable; urgency=low

  * Add patch fixing FTBFS when building twice in a row, forwarded
    upstream.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 21 Jan 2012 23:03:48 +0000

hatari (1.6.1-1) unstable; urgency=low

  * New upstream bugfix version, fixes monochrome mode.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 21 Jan 2012 10:55:39 +0000

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,15 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
-Build-Depends: debhelper (>= 7.0.50),
+Build-Depends: debhelper (>= 8),
                libsdl1.2-dev (>=1.2.6-2),
                zlib1g-dev,
                libpng12-dev,
                cmake,
                libreadline-dev,
                portaudio19-dev,
-               python-support,
-               chrpath
-Standards-Version: 3.9.2.0
+               python
+Standards-Version: 3.9.2
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake --builddirectory=build --with=python2 $@

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake \
	-O--builddirectory=build \
	-- \
	-DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	-DCMAKE_C_FLAGS:STRING="-Wl,--as-needed" \
	-DCMAKE_CXX_FLAGS:STRING="-Wl,--as-needed"
	dh_auto_configure -O--buildsystem=cmake \
	-O--builddirectory=build-winuae \
	-- \
	-DENABLE_WINUAE_CPU:BOOL=1 \
	-DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	-DCMAKE_SKIP_RPATH:BOOL=1 \
	-DCMAKE_C_FLAGS:STRING="-Wl,--as-needed" \
	-DCMAKE_CXX_FLAGS:STRING="-Wl,--as-needed"

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build-winuae

override_dh_install:
	dh_install --sourcedir=build

	# Install WinUAE version of hatari binary
	# Rename file
	mv build-winuae/src/hatari build-winuae/src/hatari-winuae
	dh_install --sourcedir=build-winuae src/hatari-winuae /usr/bin

	# Remove bundled EmuTOS image
	rm debian/hatari/usr/share/hatari/tos.img

	# Install binfmt support for atari binaries
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_installman:
	dh_installman
	dh_installman debian/hatari-winuae.1

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake -O--builddir=build
	dh_auto_clean -O--buildsystem=cmake -O--builddirectory=build-winuae
	find . -name *.pyc -exec rm -f {} \;

## hatari 1.6.2

=== debian/changelog ===
hatari (1.6.2-1) unstable; urgency=low

  * New upstream version.
    Highlights:
    - Fix 224 byte STE overscan, making Antiques by Dune work.
    - Improve audio filters for YM2149 and DMA sound.
    - Make WinUAE cpu core default to Falcon mode, and fix TOS 1.x with
      the WinUAE cpu core.
  * Build-Depend on libpng-dev instead of libpng12-dev. (Closes: #662369)
  * Use hardened build flags.
  * Bump Standards-Version, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 24 Jun 2012 15:13:16 +0100

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
-Build-Depends: debhelper (>= 8),
+Build-Depends: debhelper (>= 9),
                libsdl1.2-dev (>=1.2.6-2),
                zlib1g-dev,
-               libpng12-dev,
+               libpng-dev,
                cmake,
                libreadline-dev,
                portaudio19-dev,
                python
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari
